# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::MachineLearningServices::Mgmt::V2018_11_19
  module Models
    #
    # Describes the properties of a VM size.
    #
    class VirtualMachineSize

      include MsRestAzure

      # @return [String] Virtual Machine size name. The name of the virtual
      # machine size.
      attr_accessor :name

      # @return [String] Virtual Machine family name. The family name of the
      # virtual machine size.
      attr_accessor :family

      # @return [Integer] Number of vPUs. The number of vCPUs supported by the
      # virtual machine size.
      attr_accessor :v_cpus

      # @return [Integer] OS VHD Disk size. The OS VHD disk size, in MB,
      # allowed by the virtual machine size.
      attr_accessor :os_vhd_size_mb

      # @return [Integer] Resource volume size. The resource volume size, in
      # MB, allowed by the virtual machine size.
      attr_accessor :max_resource_volume_mb

      # @return [Float] Memory size. The amount of memory, in GB, supported by
      # the virtual machine size.
      attr_accessor :memory_gb

      # @return [Boolean] Low priority capable. Specifies if the virtual
      # machine size supports low priority VMs.
      attr_accessor :low_priority_capable

      # @return [Boolean] Premium IO supported. Specifies if the virtual
      # machine size supports premium IO.
      attr_accessor :premium_io


      #
      # Mapper for VirtualMachineSize class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'VirtualMachineSize',
          type: {
            name: 'Composite',
            class_name: 'VirtualMachineSize',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              family: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'family',
                type: {
                  name: 'String'
                }
              },
              v_cpus: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'vCPUs',
                type: {
                  name: 'Number'
                }
              },
              os_vhd_size_mb: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'osVhdSizeMB',
                type: {
                  name: 'Number'
                }
              },
              max_resource_volume_mb: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'maxResourceVolumeMB',
                type: {
                  name: 'Number'
                }
              },
              memory_gb: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'memoryGB',
                type: {
                  name: 'Double'
                }
              },
              low_priority_capable: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'lowPriorityCapable',
                type: {
                  name: 'Boolean'
                }
              },
              premium_io: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'premiumIO',
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
